var app = {
    
    // app variables
    caloriesGesamt: 0,
    caloriesGrund: 0,
    
    // Application Constructor
    initialize: function () {
        this.bindEvents();
    },

    bindEvents: function () {

        if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry)/)) {
            document.addEventListener("deviceready", this.onDeviceReady, false);
        } else {
            this.onDeviceReady();
        }


    },
    onDeviceReady: function () {

        FastClick.attach(document.body);

        $('#pal-error').hide();

        $('#calc1').validate({
            rules: {
                age: {
                    required: true,
                    number: true
                },
                weight: {
                    required: true,
                    number: true
                },
                height: {
                    required: true,
                    number: true
                }
            },
            messages: {
                age: {
                    required: "Bitte gib dein Alter ein.",
                    number: "Bitte gib eine ganze Zahl ein."
                },
                weight: {
                    required: "Bitte gib dein Gewicht ein.",
                    number: "Bitte gib eine ganze Zahl ein."
                },
                height: {
                    required: "Bitte gib deine Größe ein",
                    number: "Bitte gib eine ganze Zahl ein."
                }
            },
            errorPlacement: function (error, element) {
                error.appendTo(element.parent().prev());
            }
        });

        // catch submit in show next form page
        $("#calc1").submit(function (event) {

            if ($("#calc1").valid()) { // test for validity
                $.mobile.changePage('#calc2', {
                    transition: 'slide'
                });
            }

            event.preventDefault();
        });
        
        // change hours counter on page
        $('.pal').on('change', function () {
            var hoursUsed = app.calcHours();
            var hoursLeft = 24 - hoursUsed;

            if (hoursLeft < 0 || hoursLeft > 24) {
                $('#pal-error').show();
            } else {
                $('#pal-error').hide();
                $('#pal-hours-left').html(24 - hoursUsed);
            }
        });

        $("#calc2").submit(function (event) {
            var doSubmit = false;

            var hoursUsed = app.calcHours();
            var hoursLeft = 24 - hoursUsed;

            if (hoursLeft != 0) {
                doSubmit = false;
                $('#pal-error').show();
            }

            if (hoursLeft == 0) {
                doSubmit = true;
            }

            if (!doSubmit) {
                event.preventDefault();
            } else {
                app.calcCalories();
                $.mobile.changePage('#result', {
                    transition: 'slide'
                });
                $('#gesamtumsatz').html(app.caloriesGesamt);
                $('#grundumsatz').html(app.caloriesGrund);
                event.preventDefault();
            }
           
        });
    },
    
    calcCalories: function() {
        
        var gender = $('input[name=gender]:checked', '#calc1').val()
        var weight = parseInt($('#weight').val());
        var height = parseInt($('#height').val());
        var age = parseInt($('#age').val());
        var grundumsatz = 0;
        
        if (gender == 'male') {
            grundumsatz = 66.47 + (13.7 * weight) + (5 * height) - (6.8 * age)
        }
        
        if (gender == 'female') {
            grundumsatz = 655.1 + (9.6 * weight) + (1.8 * height) - (4.7 * age);
        }
        
        var pal095 = parseInt($("[name='sleep']").val() || 0) * 0.95;
        var pal12 = parseInt($("[name='sit']").val() || 0) * 1.2;
        var pal14 = parseInt($("[name='office']").val() || 0) * 1.4;
        var pal16 = parseInt($("[name='walk']").val() || 0) * 1.6;
        var pal18 = parseInt($("[name='waiter']").val() || 0) * 1.8;
        var pal20 = parseInt($("[name='hard']").val() || 0) * 2;
        
        
        var resultA = pal095 + pal12 + pal14 + pal16 + pal18 + pal20;
        var pal24Hours = resultA/24;
        var gesamtumsatz = Math.round(grundumsatz * pal24Hours);
        
        app.caloriesGesamt = gesamtumsatz;
        app.caloriesGrund = grundumsatz;
        
    },

    calcHours: function () {
        var palHours = 0;
        var pal095 = parseInt($("[name='sleep']").val() || 0);
        var pal12 = parseInt($("[name='sit']").val() || 0);
        var pal14 = parseInt($("[name='office']").val() || 0);
        var pal16 = parseInt($("[name='walk']").val() || 0);
        var pal18 = parseInt($("[name='waiter']").val() || 0);
        var pal20 = parseInt($("[name='hard']").val() || 0);
        palHours = pal095 + pal12 + pal14 + pal16 + pal18 + pal20;
        return palHours;
    }
};

app.initialize();